# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# We need to patch the test suite unless we have Test::More ≥ 0.88
%global old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.88) ? 1 : 0);' 2>/dev/null || echo 0)

Name:		perl-Role-Tiny
Version:	2.000005
Release:	1.%{__distinit}%{__distvers}
Summary:	A nouvelle cuisine portion size slice of Moose
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Role-Tiny/
Source0:	http://search.cpan.org/CPAN/authors/id/H/HA/HAARG/Role-Tiny-%{version}.tar.gz
Patch0:		Role-Tiny-2.000005-old-Test::More.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Module Build ------------------------------------------------
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl-generators
%endif
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime ----------------------------------------------
BuildRequires:	perl(Carp)
BuildRequires:	perl(Class::Method::Modifiers) >= 1.05
BuildRequires:	perl(Exporter)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
# Test Suite --------------------------------------------------
BuildRequires:	perl(base)
BuildRequires:	perl(constant)
BuildRequires:	perl(lib)
BuildRequires:	perl(overload)
BuildRequires:	perl(Test::More) >= 0.47
# Runtime -----------------------------------------------------
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Carp)
Requires:	perl(Class::Method::Modifiers) >= 1.05

# Handle mro dependencies
%if 0%{?fedora} > 8 || 0%{?rhel} > 5
BuildRequires:	perl(mro)
Requires:	perl(mro)
%else
BuildRequires:	perl(MRO::Compat)
Requires:	perl(MRO::Compat)
%endif

# perl-Role-Tiny was split from perl-Moo
Conflicts:	perl-Moo < 0.009014

%description
Role::Tiny is a minimalist role composition tool.

%prep
%setup -q -n Role-Tiny-%{version}

# We need to patch the test suite unless we have Test::More ≥ 0.88
%if %{old_test_more}
%patch0
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} %{buildroot}

%clean
rm -rf %{buildroot}

%check
make test

%files
%doc Changes README
%{perl_vendorlib}/Role/
%{_mandir}/man3/Role::Tiny.3*
%{_mandir}/man3/Role::Tiny::With.3*

%changelog
* Wed Nov  2 2016 Paul Howarth <paul@city-fan.org> - 2.000005-1
- Update to 2.000005
  - Revert change to MRO::Compat usage
- Update patch for building with old distributions

* Tue Nov  1 2016 Paul Howarth <paul@city-fan.org> - 2.000004-1
- Update to 2.000004
  - Fix consuming stubs from roles (CPAN RT#116674)
  - Fix error message when applying conflicting roles to an object
  - Drop prerequisite on MRO::Compat on perl 5.8
- Add patch to fix broken perl 5.8 support (CPAN RT#118583)
- Update patch for building with old distributions

* Fri Sep 23 2016 Paul Howarth <paul@city-fan.org> - 2.000003-3
- Fix FTBFS when perl is not in the minimal buildroot
- BR: perl-generators where available

* Fri Apr 22 2016 Paul Howarth <paul@city-fan.org> - 2.000003-1
- Update to 2.000003
  - Don't install subs if importing into a package that is already a role; this
    can happen if the module previously imported Moo::Role

* Wed Apr 20 2016 Paul Howarth <paul@city-fan.org> - 2.000002-1
- Update to 2.000002
  - Restore compatibility with Moo versions pre 1.004_003
  - Delay loading Class::Method::Modifiers until applying modifiers to a package
  - Use croak rather than die for reporting errors
  - Apply method modifiers only once, even if they are applied via multiple
    composition paths (CPAN RT#106668)
- Simplify find command using -delete
- Update patch for building with old distributions

* Thu Jun 25 2015 Paul Howarth <paul@city-fan.org> - 2.000001-4
- Perl 5.22 rebuild

* Sun Apr 26 2015 Paul Howarth <paul@city-fan.org> - 2.000001-1
- Update to 2.000001
  - Fix generating invalid package names with single colons when abbreviating
    long package names (CPAN RT#103310)
  - Don't run module interaction tests for user installs
- Update patch for building with old distributions

* Thu Feb 26 2015 Paul Howarth <paul@city-fan.org> - 2.000000-1
- Update to 2.000000
  - Incompatible change: Role::Tiny no longer applies fatal warnings to roles
    created with it; strict and non-fatal warnings will continue to be applied
- Update patch for building with old distributions

* Thu Oct 23 2014 Paul Howarth <paul@city-fan.org> - 1.003004-1
- Update to 1.003004
  - Allow does_role to be overridden by Moo::Role
- Classify buildreqs by usage
- Update patch for building with old distributions

* Thu Sep 11 2014 Paul Howarth <paul@city-fan.org> - 1.003003-4
- Perl 5.20 rebuild

* Wed Aug 27 2014 Paul Howarth <paul@city-fan.org> - 1.003003-3
- Don't BR: perl(namespace::autoclean) when bootstrapping
- Drop %%defattr, redundant since rpm 4.4

* Sun Mar 16 2014 Paul Howarth <paul@city-fan.org> - 1.003003-2
- BR:/R: perl(Class::Method::Modifiers) unconditionally

* Sat Mar 15 2014 Paul Howarth <paul@city-fan.org> - 1.003003-1
- Update to 1.003003
  - Overloads specified as method names rather than subrefs are now applied
    properly
  - Allow superclass to provide conflicting methods (CPAN RT#91054)
  - Use ->is_role internally to check if a package is a role
  - Document that Role::Tiny applies strict and fatal warnings
- Require Class::Method::Modifiers at runtime where possible
- Update patch for building with old distributions

* Mon Mar  3 2014 Paul Howarth <paul@city-fan.org> - 1.003002-3
- Add support for building with old distributions

* Fri Dec 20 2013 Paul Howarth <paul@city-fan.org> - 1.003002-2
- Import from Fedora

* Fri Oct 18 2013 Miro Hrončok <mhroncok@redhat.com> - 1.003002-1
- 1.003002 bump

* Fri Aug 16 2013 Jitka Plesnikova <jplesnik@redhat.com> - 1.003001-1
- 1.003001 bump
- Specify all dependencies

* Sat Aug 03 2013 Petr Pisar <ppisar@redhat.com> - 1.002005-2
- Perl 5.18 rebuild

* Fri Feb 15 2013 Iain Arnell <iarnell@gmail.com> - 1.002005-1
- Update to latest upstream version

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.002004-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Fri Nov 02 2012 Iain Arnell <iarnell@gmail.com> - 1.002004-1
- Update to latest upstream version

* Sun Oct 28 2012 Iain Arnell <iarnell@gmail.com> - 1.002002-1
- Update to latest upstream version

* Sat Oct 27 2012 Iain Arnell <iarnell@gmail.com> - 1.002001-1
- Update to latest upstream version

* Sat Oct 20 2012 Iain Arnell <iarnell@gmail.com> - 1.002000-1
- Update to latest upstream version

* Sun Jul 29 2012 Iain Arnell <iarnell@gmail.com> - 1.001005-1
- Update to latest upstream version

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.001004-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Tue Jul 17 2012 Iain Arnell <iarnell@gmail.com> - 1.001004-1
- Update to latest upstream version

* Fri Jun 22 2012 Petr Pisar <ppisar@redhat.com> - 1.001002-2
- Perl 5.16 rebuild

* Tue May 08 2012 Iain Arnell <iarnell@gmail.com> - 1.001002-1
- Update to latest upstream version

* Fri Apr 27 2012 Iain Arnell <iarnell@gmail.com> - 1.001001-1
- Update to latest upstream version
- Don't explicity require Class::Method::Modifiers

* Wed Apr 04 2012 Iain Arnell <iarnell@gmail.com> - 1.000001-1
- Update to latest upstream version

* Mon Apr 02 2012 Iain Arnell <iarnell@gmail.com> - 1.000000-3
- Explicitly conflict with perl-Moo < 0.009014; this module used to be
  distributed as part of Moo

* Mon Apr 02 2012 Iain Arnell <iarnell@gmail.com> - 1.000000-2
- Fix spelling of cuisine in summary

* Sun Apr 01 2012 Iain Arnell <iarnell@gmail.com> - 1.000000-1
- Specfile autogenerated by cpanspec 1.79
